Botan: Botan::HMAC Class Reference

Botan 1.10.17

Public Member Functions | List of all members
Botan::HMAC Class Reference

`#include <hmac.h>`

Inheritance diagram for Botan::HMAC:

## Public Member Functions
void | clear ()
MessageAuthenticationCode * | clone () const
void | final (byte out[])
SecureVector< byte > | final ()
| HMAC (HashFunction *hash)
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | output_length () const
SecureVector< byte > | process (const byte in[], size_t length)
SecureVector< byte > | process (const MemoryRegion< byte > &in)
SecureVector< byte > | process (const std::string &in)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
void | update (const byte in[], size_t length)
void | update (const MemoryRegion< byte > &in)
void | update (const std::string &str)
void | update (byte in)
template<typename T >
void | update_be (const T in)
bool | valid_keylength (size_t length) const
virtual bool | verify_mac (const byte in[], size_t length)
| ~HMAC ()

## Detailed Description

HMAC

Definition at line 19 of file hmac.h.

## Constructor & Destructor Documentation

## ◆ HMAC()

Botan::HMAC::HMAC | ( | HashFunction * | hash | ) |

Parameters

  hash | the hash to use for HMACing

Definition at line 87 of file hmac.cpp.

References Botan::HashFunction::hash_block_size(), Botan::Algorithm::name(), and Botan::MemoryRegion< T >::resize().

Referenced by clone().

87 : hash(hash_in)
88 {
89 if(hash->hash_block_size() == 0)
90 throw Invalid_Argument("HMAC cannot be used with " + hash->name());
91
92 i_key.resize(hash->hash_block_size());
93 o_key.resize(hash->hash_block_size());
94 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:217
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20
Botan::Algorithm::name
virtual std::string name() const =0
Botan::HashFunction::hash_block_size
virtual size_t hash_block_size() const
Definition: hash.h:32

## ◆ ~HMAC()

Botan::HMAC::~HMAC | ( |  | ) |
| inline

Definition at line 38 of file hmac.h.

38 { delete hash; }

## Member Function Documentation

## ◆ clear()

void Botan::HMAC::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 61 of file hmac.cpp.

References Botan::Algorithm::clear(), and Botan::zeroise().

62 {
63 hash->clear();
64 zeroise(i_key);
65 zeroise(o_key);
66 }
Botan::Algorithm::clear
virtual void clear()=0
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

MessageAuthenticationCode * Botan::HMAC::clone | ( |  | ) | const
| virtual

Get a new object representing the same algorithm as *this

Implements Botan::MessageAuthenticationCode.

Definition at line 79 of file hmac.cpp.

References Botan::HashFunction::clone(), and HMAC().

80 {
81 return new HMAC(hash->clone());
82 }
Botan::HashFunction::clone
virtual HashFunction * clone() const =0
Botan::HMAC::HMAC
HMAC(HashFunction *hash)
Definition: hmac.cpp:87

## ◆ final() [1/2]

void Botan::Buffered_Computation::final | ( | byte | out[] | ) |
| inlineinherited

Complete the computation and retrieve the final result.

Parameters

  out | The byte array to be filled with the result. Must be of length output_length()

Definition at line 80 of file buf_comp.h.

Referenced by Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::EMSA2::EMSA2(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::EMSA3::raw_data(), Botan::Randpool::reseed(), and Botan::HMAC_RNG::reseed().

80 { final_result(out); }

## ◆ final() [2/2]

SecureVector<byte> Botan::Buffered_Computation::final | ( |  | ) |
| inlineinherited

Complete the computation and retrieve the final result.

Returns
  SecureVector holding the result

Definition at line 87 of file buf_comp.h.

88 {
89 SecureVector<byte> output(output_length());
90 final_result(&output[0]);
91 return output;
92 }
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ key_spec()

Key_Length_Specification Botan::HMAC::key_spec | ( |  | ) | const
| inlinevirtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 28 of file hmac.h.

29 {
30 // Absurd max length here is to support PBKDF2
31 return Key_Length_Specification(0, 512);
32 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::HMAC::name | ( |  | ) | const
| virtual

Get the name of this algorithm.

Returns
  name of this algorithm

Implements Botan::MessageAuthenticationCode.

Definition at line 71 of file hmac.cpp.

References Botan::Algorithm::name().

72 {
73 return "HMAC(" + hash->name() + ")";
74 }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ output_length()

size_t Botan::HMAC::output_length | ( |  | ) | const
| inlinevirtual

Returns
  length of the output of this function in bytes

Implements Botan::Buffered_Computation.

Definition at line 26 of file hmac.h.

26 { return hash->output_length(); }
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ process() [1/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a byte array
  length | the length of the byte array

Returns
  the result of the call to final()

Definition at line 101 of file buf_comp.h.

Referenced by Botan::Randpool::add_entropy(), Botan::EME1::EME1(), and Botan::Cert_Extension::Subject_Key_ID::Subject_Key_ID().

102 {
103 add_data(in, length);
104 return final();
105 }

## ◆ process() [2/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const MemoryRegion< byte > & | in | ) |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process

Returns
  the result of the call to final()

Definition at line 113 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

114 {
115 add_data(&in[0], in.size());
116 return final();
117 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ process() [3/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const std::string & | in | ) |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a string

Returns
  the result of the call to final()

Definition at line 125 of file buf_comp.h.

126 {
127 update(in);
128 return final();
129 }
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ update() [1/4]

void Botan::Buffered_Computation::update | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inlineinherited

Add new input to process.

Parameters

  in | the input to process as a byte array
  length | of param in in bytes

Definition at line 33 of file buf_comp.h.

Referenced by Botan::HMAC_RNG::add_entropy(), Botan::Comb4P::clear(), Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::start_msg(), and Botan::EMSA3::update().

33 { add_data(in, length); }

## ◆ update() [2/4]

void Botan::Buffered_Computation::update | ( | const MemoryRegion< byte > & | in | ) |
| inlineinherited

Add new input to process.

Parameters

  in | the input to process as a MemoryRegion

Definition at line 39 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

40 {
41 add_data(&in[0], in.size());
42 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ update() [3/4]

void Botan::Buffered_Computation::update | ( | const std::string & | str | ) |
| inlineinherited

Add new input to process.

Parameters

  str | the input to process as a std::string. Will be interpreted as a byte array based on the strings encoding.

Definition at line 63 of file buf_comp.h.

64 {
65 add_data(reinterpret_cast<const byte*>(str.data()), str.size());
66 }

## ◆ update() [4/4]

void Botan::Buffered_Computation::update | ( | byte | in | ) |
| inlineinherited

Process a single byte.

Parameters

  in | the byte to process

Definition at line 72 of file buf_comp.h.

72 { add_data(&in, 1); }

## ◆ update_be()

template<typename T >

void Botan::Buffered_Computation::update_be | ( | const T | in | ) |
| inlineinherited

Add an integer in big-endian order

Parameters

  in | the value

Definition at line 48 of file buf_comp.h.

References Botan::get_byte().

Referenced by Botan::KDF2::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::Record_Reader::get_record(), and Botan::MGF1::mask().

49 {
50 for(size_t i = 0; i != sizeof(T); ++i)
51 {
52 byte b = get_byte(i, in);
53 add_data(&b, 1);
54 }
55 }
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::byte
unsigned char byte
Definition: types.h:22

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ verify_mac()

bool Botan::MessageAuthenticationCode::verify_mac | ( | const byte | in[],
|  | size_t | length
| ) |  |
| virtualinherited

Verify a MAC.

Parameters

  in | the MAC to verify as a byte array
  length | the length of param in

Returns
  true if the MAC is valid, false otherwise

Definition at line 16 of file mac.cpp.

17 {
18 SecureVector<byte> our_mac = final();
19
20 if(our_mac.size() != length)
21 return false;
22
23 return same_mem(&our_mac[0], &mac[0], length);
24 }
Botan::same_mem
bool same_mem(const T *p1, const T *p2, size_t n)
Definition: mem_ops.h:57

The documentation for this class was generated from the following files:

- src/mac/hmac/hmac.h
- src/mac/hmac/hmac.cpp